/**
 * @file Fonctions et classes de cache
 * @author hadi
 * @namespace cache
 */

type Creator<K, T> = (id: K) => Promise<T>;

export class Cache<A, K> {
    /**
     * @memberof cache
     * @class Cache
     * @summary Permet le caching d'une classe A référencée par des keys K
     */


    instances = new Map<K, Promise<A>>();

    async get(k: K, create: Creator<K, A>): Promise<A> {
        if (this.instances.has(k)) {
            return this.instances.get(k);
        }
        else {
            const a = create(k);
            this.instances.set(k, a);
            return a;
        }
    }
}

