/**
 * @file Classe qui gere le chargement asynchrone de données
 * @author ofacklam
 * @memberof GraphQL
 */

type LoaderFun = () => Promise<boolean>;

export class DataLoader {

    protected m_promise : Promise<boolean> = null;
    protected m_loader : LoaderFun;

    constructor(loader_fn : LoaderFun) {
        this.m_loader = loader_fn;
    }

    load() : Promise<boolean> {
        if(this.m_promise === null) {
            this.m_promise = this.m_loader();
        }

        return this.m_promise;
    }

}